#-----------------------------------------------------
# Scene_Load
# ロードのシーンクラス
# 2019.06.09 レベルの廃止、常にLv.1に
#-----------------------------------------------------
class Scene_Load < Scene_Base
  # 初期化
  def initialize(*ext)
    super
    create_background
  end
  # 全てのウィンドウを作成
  def create_all_windows
    super
    @windows[:load] = Window_Load.new(227,178,659,370)
    @windows[:load].set_handler(:ok, method(:load_ok))
    @windows[:load].set_handler(:cancel, method(:load_cancel))
    @windows[:load].up_down_img_xy(nil,172,nil,nil)
    @windows[:load].display_up_down = true
    @windows[:load].refresh
    @windows[:load].active
    @windows[:load].select(DataManager.last_savefile_index)
  end
  # 背景を作成
  def create_background
    @bg= Sprite_Pis.new("data/img/menu/load.pis", 0, 0)
  end
  # ロード
  def load_ok
    if @windows[:load].load_file
      # Window_Load#load_fileがロード失敗時にfalseを返すことを利用し
      # 存在しないファイルを選択したときのエラーを回避する
      $system.on_after_load
      #--- ロードしたデータもレベルを１に、ステータスも変更 ---#
      $player.level = 1
      #--- 解放されていないスロットに入っているプラグインを外す ---#
      $player.equip_plugin[4] = nil unless $game_switches[9991]
      $player.equip_plugin[5] = nil unless $game_switches[9992]
      #--- 前編のGame_Systemで未定義のインスタンス変数を定義 ---#
      $player.init_stats
      $system.set_undefined_var
      #--- チャプター解放メタ打ち ---#
      if $player.encount_enemies.include?(52) #前編クリア
        $player.chg_name("ユール")
        $system.chapter.push(1,2,3,4,5,6,7,8,9,10,11,12,13,14)
        $system.chapter.uniq!
      end
      if $player.encount_enemies.include?(120) #中編クリア
        $system.chapter.push(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,34,35)
        $system.chapter.uniq!
      end
      if $player.encount_enemies.include?(106) #ラグニアクリア
        $system.chapter.push(33)
        $system.chapter.uniq!
      end
      ############# 救済用メタ打ち ##############
      # Ver.1.00発生、敗北回想同時実行問題
      $game_switches[10142] = false
      $game_switches[10170] = false
      $game_switches[10167] = false
      $game_switches[10168] = false
      $game_switches[10175] = false
      # ver.1.01発生、ユーロ・ラグニア開放失敗
      $player.already_map << 302 if $game_switches[8357]
      #----------------------------------------------------#
      $player.x = $system.save_pos[:x]
      $player.y = $system.save_pos[:y]
      $player.dir = $system.save_pos[:dir]
      SceneManager.goto(Scene_Map, :black, $system.save_pos[:map])
      SceneManager.clear
      Audio.stop_bgm
      Audio.delete_bgm(:title)
    end
  end
  # ロードキャンセル
  def load_cancel
    SceneManager.return
  end
  # 更新
  def update
    @bg.update
    @bg.draw
    super
  end
  # 解放
  def dispose
    super
    @bg.dispose
    @bg = nil
  end
end
